'use strict';

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

Object.defineProperty(exports, "__esModule", {
	value: true
});
exports.EmojiWrapper = exports.SingleEmoji = undefined;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _gemoji = require('gemoji');

var _gemoji2 = _interopRequireDefault(_gemoji);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var wrapperStyle = {
	display: 'inline-block',
	marginTop: 2,
	marginBottom: 2,
	marginRight: 4,
	padding: '1px 3px',
	borderRadius: 5,
	backgroundColor: '#fff',
	border: '1px solid #E8E8E8',
	cursor: 'pointer',
	height: '1.4rem',
	lineHeight: '23px',
	WebkitUserSelect: 'none',
	msUserSelect: 'none',
	MozUserSelect: 'none'
};

var emojiStyle = {
	lineHeight: '20px',
	verticalAlign: 'middle',
	display: 'inline-block'
};

var wrapperHover = {
	border: '1px solid #4fb0fc'
};

var countStyle = {
	fontSize: 11,
	fontFamily: 'helvetica, arial',
	position: 'relative',
	top: -2,
	padding: '0 1px 3px',
	color: '#959595'
};

var countHover = {
	color: "#4fb0fc"
};

var selectorStyle = {
	boxShadow: '0 6px 8px 0 rgba(0, 0, 0, 0.24)',
	backgroundColor: '#fff',
	width: 250,
	height: 150,
	overflow: 'auto',
	position: 'relative',
	left: 10,
	top: 0
};

var SingleEmoji = exports.SingleEmoji = function (_Component) {
	_inherits(SingleEmoji, _Component);

	function SingleEmoji() {
		_classCallCheck(this, SingleEmoji);

		var _this = _possibleConstructorReturn(this, Object.getPrototypeOf(SingleEmoji).call(this));

		_this.state = { hovered: false };
		return _this;
	}

	_createClass(SingleEmoji, [{
		key: 'render',
		value: function render() {
			var _this2 = this;

			var _props = this.props;
			var name = _props.name;
			var _props$count = _props.count;
			var count = _props$count === undefined ? 1 : _props$count;
			var _props$styles = _props.styles;
			var styles = _props$styles === undefined ? {
				wrapperStyle: wrapperStyle,
				emojiStyle: emojiStyle,
				countStyle: countStyle,
				wrapperHover: wrapperHover,
				countHover: countHover
			} : _props$styles;
			var _props$onClick = _props.onClick;

			var _onClick = _props$onClick === undefined ? function () {} : _props$onClick;

			var wrapperFinalStyle = this.state.hovered ? _extends({}, wrapperStyle, wrapperHover) : wrapperStyle;
			var countFinalStyle = this.state.hovered ? _extends({}, countStyle, countHover) : countStyle;
			return _react2.default.createElement(
				'div',
				{
					style: wrapperFinalStyle,
					onClick: function onClick() {
						return _onClick(name);
					},
					onMouseEnter: function onMouseEnter() {
						return _this2.setState({ hovered: true });
					},
					onMouseLeave: function onMouseLeave() {
						return _this2.setState({ hovered: false });
					}
				},
				_react2.default.createElement(
					'span',
					{ style: emojiStyle },
					_gemoji2.default.name[name].emoji
				),
				_react2.default.createElement(
					'span',
					{ style: countFinalStyle },
					count
				)
			);
		}
	}]);

	return SingleEmoji;
}(_react.Component);

var EmojiWrapper = exports.EmojiWrapper = function EmojiWrapper(_ref) {
	var reactions = _ref.reactions;
	var onReaction = _ref.onReaction;

	return _react2.default.createElement(
		'div',
		{ style: { display: 'inline-block' } },
		reactions.map(function (_ref2) {
			var name = _ref2.name;
			var count = _ref2.count;
			return _react2.default.createElement(SingleEmoji, { name: name, count: count, key: name, onClick: onReaction });
		})
	);
};

var EmojiSelector = function (_Component2) {
	_inherits(EmojiSelector, _Component2);

	function EmojiSelector() {
		_classCallCheck(this, EmojiSelector);

		var _this3 = _possibleConstructorReturn(this, Object.getPrototypeOf(EmojiSelector).call(this));

		_this3.state = { filter: "" };
		return _this3;
	}

	_createClass(EmojiSelector, [{
		key: 'render',
		value: function render() {
			var _this4 = this;

			var _props2 = this.props;
			var showing = _props2.showing;
			var onEmojiClick = _props2.onEmojiClick;

			if (!showing) {
				return null;
			}
			var searchInput = _react2.default.createElement(
				'div',
				null,
				_react2.default.createElement('input', {
					style: { margin: 10, width: '90%', borderRadius: 5, border: '1px solid #E8E8E8' },
					type: 'text',
					placeholder: 'Search',
					value: this.state.filter,
					onChange: function onChange(e) {
						return _this4.setState({ filter: e.target.value });
					}
				})
			);
			var show = Object.keys(_gemoji2.default.name).filter(function (name) {
				return name.indexOf(_this4.state.filter) !== -1;
			});
			var emojis = show.map(function (em) {
				return _react2.default.createElement(
					'span',
					{
						style: { cursor: 'pointer' },
						key: em,
						onClick: function onClick() {
							return onEmojiClick(em);
						}
					},
					_gemoji2.default.name[em].emoji
				);
			});
			return _react2.default.createElement(
				'div',
				{ style: selectorStyle },
				searchInput,
				_react2.default.createElement(
					'div',
					{ style: { padding: 15, paddingTop: 5, width: '90%' } },
					emojis
				)
			);
		}
	}]);

	return EmojiSelector;
}(_react.Component);

var EmojiReact = function (_Component3) {
	_inherits(EmojiReact, _Component3);

	function EmojiReact() {
		_classCallCheck(this, EmojiReact);

		var _this5 = _possibleConstructorReturn(this, Object.getPrototypeOf(EmojiReact).call(this));

		_this5.state = { hovered: false, showSelector: false };
		return _this5;
	}

	_createClass(EmojiReact, [{
		key: 'render',
		value: function render() {
			var _this6 = this;

			var _props3 = this.props;
			var reactions = _props3.reactions;
			var onReaction = _props3.onReaction;
			var onEmojiClick = _props3.onEmojiClick;

			var plusButtonStyle = this.state.hovered ? _extends({}, wrapperStyle, wrapperHover) : wrapperStyle;
			var plusStyle = this.state.hovered ? _extends({}, countStyle, countHover) : countStyle;
			var selector = _react2.default.createElement(
				'div',
				{ style: { display: 'inline-block' } },
				_react2.default.createElement(
					'div',
					{
						style: plusButtonStyle,
						onMouseEnter: function onMouseEnter() {
							return _this6.setState({ hovered: true });
						},
						onMouseLeave: function onMouseLeave() {
							return _this6.setState({ hovered: false });
						},
						onClick: function onClick() {
							return _this6.setState({ showSelector: !_this6.state.showSelector });
						}
					},
					_react2.default.createElement(
						'span',
						{ style: plusStyle },
						'+'
					)
				),
				_react2.default.createElement(EmojiSelector, { showing: this.state.showSelector, onEmojiClick: onEmojiClick })
			);
			return _react2.default.createElement(
				'div',
				{ style: { display: 'inline-flex' } },
				_react2.default.createElement(EmojiWrapper, { onReaction: onReaction, reactions: reactions }),
				selector
			);
		}
	}]);

	return EmojiReact;
}(_react.Component);

exports.default = EmojiReact;